﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Task12PostGrad.Models;

namespace Task12PostGrad.Migrations
{
    [DbContext(typeof(PostGradDbContext))]
    partial class PostGradDbContextModelSnapshot : ModelSnapshot
    {
        protected override void BuildModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "3.1.7")
                .HasAnnotation("Relational:MaxIdentifierLength", 128)
                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

            modelBuilder.Entity("Task12PostGrad.Models.Professor", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("FirstName")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("LastName")
                        .HasColumnType("nvarchar(max)");

                    b.HasKey("Id");

                    b.ToTable("Professors");

                    b.HasData(
                        new
                        {
                            Id = 1,
                            FirstName = "Nick",
                            LastName = "Lennox"
                        },
                        new
                        {
                            Id = 2,
                            FirstName = "Nickyboi",
                            LastName = "Lennnox"
                        },
                        new
                        {
                            Id = 3,
                            FirstName = "Dewald",
                            LastName = "IdontKnow"
                        },
                        new
                        {
                            Id = 4,
                            FirstName = "Irfa",
                            LastName = "Naza"
                        },
                        new
                        {
                            Id = 5,
                            FirstName = "Irfannn",
                            LastName = "Naazaaaand"
                        });
                });

            modelBuilder.Entity("Task12PostGrad.Models.Project", b =>
                {
                    b.Property<int>("ProjectId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<int>("ProfessorId")
                        .HasColumnType("int");

                    b.Property<string>("Subject")
                        .HasColumnType("nvarchar(max)");

                    b.HasKey("ProjectId");

                    b.HasIndex("ProfessorId");

                    b.ToTable("Projects");

                    b.HasData(
                        new
                        {
                            ProjectId = 1,
                            ProfessorId = 1,
                            Subject = "Java"
                        },
                        new
                        {
                            ProjectId = 2,
                            ProfessorId = 1,
                            Subject = ".NET"
                        });
                });

            modelBuilder.Entity("Task12PostGrad.Models.Student", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("FirstName")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("LastName")
                        .HasColumnType("nvarchar(max)");

                    b.Property<int>("ProfessorId")
                        .HasColumnType("int");

                    b.HasKey("Id");

                    b.HasIndex("ProfessorId");

                    b.ToTable("Students");

                    b.HasData(
                        new
                        {
                            Id = 1,
                            FirstName = "Irfan",
                            LastName = "Nazand",
                            ProfessorId = 1
                        },
                        new
                        {
                            Id = 2,
                            FirstName = "Sven",
                            LastName = "Richard",
                            ProfessorId = 1
                        });
                });

            modelBuilder.Entity("Task12PostGrad.Models.StudentProject", b =>
                {
                    b.Property<int>("StudenId")
                        .HasColumnType("int");

                    b.Property<int>("ProjectId")
                        .HasColumnType("int");

                    b.Property<int?>("StudentId")
                        .HasColumnType("int");

                    b.HasKey("StudenId", "ProjectId");

                    b.HasIndex("ProjectId");

                    b.HasIndex("StudentId");

                    b.ToTable("StudentProjects");
                });

            modelBuilder.Entity("Task12PostGrad.Models.Project", b =>
                {
                    b.HasOne("Task12PostGrad.Models.Professor", "Professor")
                        .WithMany("Projects")
                        .HasForeignKey("ProfessorId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Task12PostGrad.Models.Student", b =>
                {
                    b.HasOne("Task12PostGrad.Models.Professor", "Professor")
                        .WithMany("Students")
                        .HasForeignKey("ProfessorId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Task12PostGrad.Models.StudentProject", b =>
                {
                    b.HasOne("Task12PostGrad.Models.Project", "Project")
                        .WithMany("StudentProjects")
                        .HasForeignKey("ProjectId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Task12PostGrad.Models.Student", "Student")
                        .WithMany("StudentProjects")
                        .HasForeignKey("StudentId");
                });
#pragma warning restore 612, 618
        }
    }
}
